## dde-cooperation 1.1.21

=== src/CMakeLists.txt ===
# some base common libraries
add_subdirectory(infrastructure)

# share libraries
add_subdirectory(lib)

add_subdirectory(apps)

if(ENABLE_SLOTIPC)
    # compat v20 daemon app
    add_subdirectory(compat)
endif()

=== 3rdparty/QtZeroConf/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.4)
project(QtZeroConf VERSION 0.1.0)

find_package(QT NAMES Qt6 Qt5 REQUIRED COMPONENTS Core Network)
find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core Network)

set(CMAKE_AUTOMOC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(PUBLIC_HEADERS
    qzeroconfservice.h
    qzeroconfglobal.h
    qzeroconf.h
)
add_library(QtZeroConf
    ${PUBLIC_HEADERS}
    qzeroconfservice.cpp
)

include(GNUInstallDirs)

if(BUILD_SHARED_LIBS)
    target_compile_definitions(QtZeroConf PRIVATE QT_BUILD_ZEROCONF_LIB)
    set_target_properties(QtZeroConf PROPERTIES VERSION ${PROJECT_VERSION} SOVERSION 0)
else()
    target_compile_definitions(QtZeroConf PUBLIC QZEROCONF_STATIC)
endif()

if(${CMAKE_SYSTEM_NAME} STREQUAL "Linux" OR ${CMAKE_SYSTEM_NAME} STREQUAL "FreeBSD")
    find_library(avahi-client-lib avahi-client REQUIRED)
    find_library(avahi-common-lib avahi-common REQUIRED)
    find_path(avahi-client-includes avahi-client/client.h REQUIRED)
    find_path(avahi-common-includes avahi-common/defs.h REQUIRED)
    target_sources(QtZeroConf PRIVATE
        avahi-qt/qt-watch_p.h
        avahi-qt/qt-watch.cpp
        avahiclient.cpp
    )
    target_include_directories(QtZeroConf PRIVATE ${avahi-client-includes} ${avahi-common-includes})
    list(APPEND ${PUBLIC_HEADERS}
        avahi-qt/qt-watch.h
    )
    target_link_libraries(QtZeroConf PRIVATE ${avahi-client-lib} ${avahi-common-lib})
endif()

if(APPLE)
    target_sources(QtZeroConf PRIVATE
        bonjour_p.h
        bonjour.cpp
    )
    find_library(CoreServices CoreServices)
    target_link_libraries(QtZeroConf PUBLIC ${CoreServices})
endif()

target_include_directories(QtZeroConf PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
    $<INSTALL_INTERFACE:include/QtZeroConf>
)
target_link_libraries(QtZeroConf PUBLIC Qt${QT_VERSION_MAJOR}::Core Qt${QT_VERSION_MAJOR}::Network)

if(WIN32)
    target_sources(QtZeroConf PRIVATE
        bonjour_p.h
        bonjour.cpp
        bonjour-sdk/dnssd_clientlib.c
        bonjour-sdk/dnssd_clientstub.c
        bonjour-sdk/dnssd_ipc.c
    )
    target_link_libraries(QtZeroConf PUBLIC ws2_32)
    if(MSVC)
        target_link_libraries(QtZeroConf PUBLIC "legacy_stdio_definitions.lib")
    endif()
    target_compile_definitions(QtZeroConf PRIVATE
        -DWIN32
        -D_USRDLL
        -DMDNS_DEBUGMSGS=0
        -DWIN32_LEAN_AND_MEAN
        -DUSE_TCP_LOOPBACK
        -D_NO_CRT_STDIO_INLINE
        -D_CRT_SECURE_NO_DEPRECATE
        -D_CRT_SECURE_CPP_OVERLOAD_STANDARD_NAMES=1
        -DNOT_HAVE_SA_LEN)
    target_include_directories(QtZeroConf PRIVATE "${CMAKE_CURRENT_LIST_DIR}/bonjour-sdk")
endif()

if(ANDROID_AVAHI)
     set(ACM "${CMAKE_CURRENT_LIST_DIR}/avahi-common")
     set(ACR "${CMAKE_CURRENT_LIST_DIR}/avahi-core")
     target_sources(QtZeroConf PRIVATE
        qzeroconf.h
        avahi-qt/qt-watch.h
        avahi-qt/qt-watch_p.h
        avahicore.cpp
        avahi-qt/qt-watch.cpp
        ${ACM}/address.c
        ${ACM}/alternative.c
        ${ACM}/domain.c
        ${ACM}/error.c
        ${ACM}/i18n.c
        ${ACM}/malloc.c
        ${ACM}/rlist.c
        ${ACM}/simple-watch.c
        ${ACM}/strlst.c
        ${ACM}/thread-watch.c
        ${ACM}/timeval.c
        ${ACM}/utf8.c
        ${ACR}/addr-util.c
        ${ACR}/announce.c
        ${ACR}/browse.c
        ${ACR}/browse-dns-server.c
        ${ACR}/browse-domain.c
        ${ACR}/browse-service.c
        ${ACR}/browse-service-type.c
        ${ACR}/cache.c
        ${ACR}/dns.c
        ${ACR}/domain-util.c
        ${ACR}/entry.c
        ${ACR}/fdutil.c
        ${ACR}/hashmap.c
        ${ACR}/iface.c
        ${ACR}/iface-linux.c
        ${ACR}/log.c
        ${ACR}/multicast-lookup.c
        ${ACR}/netlink.c
        ${ACR}/prioq.c
        ${ACR}/probe-sched.c
        ${ACR}/querier.c
        ${ACR}/query-sched.c
        ${ACR}/resolve-address.c
        ${ACR}/resolve-host-name.c
        ${ACR}/resolve-service.c
        ${ACR}/response-sched.c
        ${ACR}/rr.c
        ${ACR}/rrlist.c
        ${ACR}/server.c
        ${ACR}/socket.c
        ${ACR}/timeeventq.c
        ${ACR}/util.c
        ${ACR}/wide-area.c
    )
    list(APPEND ${PUBLIC_HEADERS}
        avahi-qt/qt-watch.h
    )
    target_compile_definitions(QtZeroConf PRIVATE HAVE_STRLCPY GETTEXT_PACKAGE HAVE_NETLINK)
elseif(ANDROID)
    target_sources(QtZeroConf PRIVATE
        qzeroconf.h
        androidnsd_p.h
        androidnsd.cpp
    )
    find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Gui)
    target_link_libraries(QtZeroConf PUBLIC Qt${QT_VERSION_MAJOR}::Gui)
    if (QT_VERSION_MAJOR EQUAL 5)
        find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS AndroidExtras)
        target_link_libraries(QtZeroConf PUBLIC Qt${QT_VERSION_MAJOR}::AndroidExtras)
    endif ()
endif()

# install
set(INSTALL_CMAKEDIR "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}" CACHE STRING "Installation directory for cmake config files")
set_target_properties(QtZeroConf PROPERTIES PUBLIC_HEADER
    "${PUBLIC_HEADERS}"
)
install(TARGETS QtZeroConf
    EXPORT QtZeroConfConfig
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${PROJECT_NAME}
)
export(TARGETS QtZeroConf
    FILE ${CMAKE_CURRENT_BINARY_DIR}/QtZeroConfConfig.cmake
)
install(EXPORT QtZeroConfConfig
    DESTINATION ${INSTALL_CMAKEDIR}
)

set(BUILD_EXAMPLE false)
if(BUILD_EXAMPLE)
    add_subdirectory(example)
endif()

=== 3rdparty/protobuf/CMakeLists.txt ===
﻿cmake_minimum_required(VERSION 3.1.3)
project(protobuf C CXX)

add_definitions(-DGOOGLE_PROTOBUF_CMAKE_BUILD)

if (MSVC)
  # Build with multiple processes
  add_definitions(/MP)
  # MSVC warning suppressions
  add_definitions(
    /wd4018 # 'expression' : signed/unsigned mismatch
    /wd4065 # switch statement contains 'default' but no 'case' labels
    /wd4146 # unary minus operator applied to unsigned type, result still unsigned
    /wd4244 # 'conversion' conversion from 'type1' to 'type2', possible loss of data
    /wd4251 # 'identifier' : class 'type' needs to have dll-interface to be used by clients of class 'type2'
    /wd4267 # 'var' : conversion from 'size_t' to 'type', possible loss of data
    /wd4305 # 'identifier' : truncation from 'type1' to 'type2'
    /wd4307 # 'operator' : integral constant overflow
    /wd4309 # 'conversion' : truncation of constant value
    /wd4334 # 'operator' : result of 32-bit shift implicitly converted to 64 bits (was 64-bit shift intended?)
    /wd4355 # 'this' : used in base member initializer list
    /wd4506 # no definition for inline function 'function'
    /wd4800 # 'type' : forcing value to bool 'true' or 'false' (performance warning)
    /wd4996 # The compiler encountered a deprecated declaration.
  )
  # Allow big object
  add_definitions(/bigobj)

  # Suppress linker warnings about files with no symbols defined.
  set(CMAKE_STATIC_LINKER_FLAGS /ignore:4221)
endif (MSVC)

find_package(Threads REQUIRED)
if (CMAKE_USE_PTHREADS_INIT)
	add_definitions(-DHAVE_PTHREAD)
endif (CMAKE_USE_PTHREADS_INIT)


include_directories(${CMAKE_CURRENT_SOURCE_DIR}/src)

#add_definitions(-DUNICODE -D_UNICODE)

file(GLOB LIBPROTOBUF_FILES
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/any.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/any.pb.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/api.pb.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/compiler/importer.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/compiler/parser.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/descriptor.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/descriptor.pb.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/descriptor_database.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/duration.pb.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/dynamic_message.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/empty.pb.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/extension_set_heavy.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/field_mask.pb.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/generated_message_reflection.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/generated_message_table_driven.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/io/gzip_stream.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/io/printer.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/io/tokenizer.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/io/zero_copy_stream_impl.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/map_field.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/message.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/reflection_ops.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/service.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/source_context.pb.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/struct.pb.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/stubs/mathlimits.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/stubs/substitute.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/text_format.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/timestamp.pb.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/type.pb.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/unknown_field_set.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/delimited_message_util.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/field_comparator.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/field_mask_util.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/internal/datapiece.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/internal/default_value_objectwriter.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/internal/error_listener.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/internal/field_mask_utility.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/internal/json_escaping.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/internal/json_objectwriter.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/internal/json_stream_parser.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/internal/object_writer.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/internal/proto_writer.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/internal/protostream_objectsource.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/internal/protostream_objectwriter.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/internal/type_info.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/internal/type_info_test_helper.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/internal/utility.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/json_util.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/message_differencer.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/time_util.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/type_resolver_util.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/wire_format.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/wrappers.pb.cc
)

file(GLOB LIBPROTOBUF_INCLUDES
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/any.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/any.pb.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/api.pb.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/compiler/importer.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/compiler/parser.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/descriptor.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/descriptor.pb.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/descriptor_database.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/duration.pb.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/dynamic_message.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/empty.pb.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/field_mask.pb.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/generated_message_reflection.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/io/gzip_stream.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/io/printer.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/io/tokenizer.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/io/zero_copy_stream_impl.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/map_field.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/message.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/reflection_ops.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/service.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/source_context.pb.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/struct.pb.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/stubs/mathlimits.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/stubs/substitute.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/text_format.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/timestamp.pb.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/type.pb.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/unknown_field_set.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/delimited_message_util.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/field_comparator.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/field_mask_util.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/internal/datapiece.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/internal/default_value_objectwriter.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/internal/error_listener.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/internal/field_mask_utility.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/internal/json_escaping.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/internal/json_objectwriter.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/internal/json_stream_parser.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/internal/object_writer.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/internal/proto_writer.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/internal/protostream_objectsource.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/internal/protostream_objectwriter.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/internal/type_info.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/internal/type_info_test_helper.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/internal/utility.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/json_util.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/message_differencer.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/time_util.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/type_resolver_util.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/wire_format.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/wrappers.pb.h
)

file(GLOB LIBPROTOBUF_LITE_FILES
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/arena.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/arenastring.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/extension_set.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/generated_message_table_driven_lite.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/generated_message_util.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/implicit_weak_message.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/io/coded_stream.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/io/zero_copy_stream.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/io/zero_copy_stream_impl_lite.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/message_lite.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/repeated_field.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/stubs/bytestream.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/stubs/common.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/stubs/int128.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/stubs/io_win32.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/stubs/status.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/stubs/statusor.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/stubs/stringpiece.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/stubs/stringprintf.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/stubs/structurally_valid.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/stubs/strutil.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/io/strtod.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/stubs/time.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/wire_format_lite.cc
)

file(GLOB LIBPROTOBUF_LITE_INCLUDES
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/arena.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/arenastring.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/extension_set.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/generated_message_util.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/implicit_weak_message.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/io/coded_stream.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/io/strtod.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/io/zero_copy_stream.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/io/zero_copy_stream_impl_lite.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/message_lite.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/repeated_field.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/stubs/bytestream.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/stubs/common.h

=== src/apps/CMakeLists.txt ===
﻿add_subdirectory(dde-cooperation)

if (CMAKE_SYSTEM MATCHES "Linux")
    add_subdirectory(dde-cooperation-transfer)
endif()

add_subdirectory(data-transfer)

# launcher
# add_subdirectory("launcher")

=== src/compat/CMakeLists.txt ===
﻿if(NOT TARGET COMPAT_DEAMON)
    include("${CMAKE_SOURCE_DIR}/modules/compat.cmake")

    set(COMPAT_ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}")
    include_directories(${COMPAT_ROOT_DIR})
    include_directories(${COMPAT_ROOT_DIR}/include)

    # zrpc module base on coost library
    set(ZRPC_DIR "${COMPAT_ROOT_DIR}/zrpc")
    include_directories(${ZRPC_DIR}/include)
    add_subdirectory("${ZRPC_DIR}" zrpc)    

    add_subdirectory(protocol)

    set(CMAKE_AUTOUIC ON)
    set(CMAKE_AUTOMOC ON)
    set(CMAKE_AUTORCC ON)

    add_subdirectory(framework)
    add_subdirectory(plugins)

    add_subdirectory(apps)

endif()

=== src/infrastructure/CMakeLists.txt ===
if(ENABLE_SLOTIPC)
    include("slotipc.cmake")
endif()

# the ssl configuration module, must before Compiler features
add_subdirectory(sslconf)

# Compiler features
include(SetCompilerFeatures)
include(SetPlatformFeatures)
include(SystemInformation)
if (NOT ANDROID)
include(SetCompilerWarnings)
endif()

# uuid library first for android
if (ANDROID)
include("android-uuid.cmake")
include_directories(${CMAKE_CURRENT_SOURCE_DIR})
endif()

# import non-boost asio
include("asio.cmake")

# build the base kit first
add_subdirectory(basekit)

if (NOT ANDROID)
add_subdirectory(logging)
endif()

# network utils
add_subdirectory(netutil)

# rpc module for compat old protocal
# add_subdirectory(zrpc)

=== 3rdparty/QtZeroConf/example/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.4)
project(QtZeroConfExample)

find_package(QT NAMES Qt6 Qt5 COMPONENTS Core Network REQUIRED)
find_package(Qt${QT_VERSION_MAJOR} COMPONENTS Core Network Gui Widgets REQUIRED)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTORCC ON)

# Find QtZeroConf library if we're building standalone
if(NOT TARGET QtZeroConf)
    find_package(QtZeroConf CONFIG REQUIRED)
endif()

add_executable(QtZeroConfExample
    window.h
    window.cpp
    main.cpp
)

target_link_libraries(QtZeroConfExample
    QtZeroConf
    Qt${QT_VERSION_MAJOR}::Gui
    Qt${QT_VERSION_MAJOR}::Widgets
)

=== 3rdparty/coost/gen/CMakeLists.txt ===
file(GLOB SRC_FILES *.cc)

add_executable(gen ${SRC_FILES})
target_link_libraries(gen PRIVATE co)

=== 3rdparty/coost/src/CMakeLists.txt ===
# Build co library
file(GLOB_RECURSE CO_SRC_FILES ${CMAKE_CURRENT_SOURCE_DIR}/*.cc)

if(MSVC)
    if(CMAKE_SIZEOF_VOID_P EQUAL 4)
        set(ASM_FILES co/context/context_x86.asm)
    else()
        set(ASM_FILES co/context/context_x64.asm)
    endif()
    set_property(SOURCE ${ASM_FILES} PROPERTY LANGUAGE ASM_MASM)
else()
    set(ASM_FILES co/context/context.S co/context/context.cc)
endif()
list(APPEND CO_SRC_FILES ${ASM_FILES})

if(WIN32)
    list(APPEND CO_SRC_FILES
        log/StackWalker.cpp
        co/detours/creatwth.cpp
        co/detours/detours.cpp
        co/detours/image.cpp
        co/detours/modules.cpp
        co/detours/disasm.cpp
    )
endif()

if(APPLE)
    list(APPEND CO_SRC_FILES co/fishhook/fishhook.c)
endif()

add_library(co ${CO_SRC_FILES})
add_library(coost::co ALIAS co)

target_include_directories(co
    PUBLIC
        $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
        $<INSTALL_INTERFACE:$<INSTALL_PREFIX>/${CMAKE_INSTALL_INCLUDEDIR}>
)

set_target_properties(co PROPERTIES
    VERSION ${PROJECT_VERSION}
    SOVERSION ${PROJECT_VERSION_MAJOR}
)

if(WITH_LIBCURL)
    find_package(CURL REQUIRED)
    target_compile_definitions(co PRIVATE HAS_LIBCURL)
    target_link_libraries(co PRIVATE CURL::libcurl)
endif()
if(WITH_LIBCURL OR WITH_OPENSSL)
    find_package(OpenSSL 1.1.0 REQUIRED)
    target_compile_definitions(co PRIVATE HAS_OPENSSL)
    target_link_libraries(co PRIVATE OpenSSL::SSL OpenSSL::Crypto)
    if(WIN32)
        # FindOpenSSL.cmake shipped in CMake < 3.21.0 doesn't properly propagate
        # crypt32. We should also handle ws2_32 but coost link to it later.
        target_link_libraries(co PRIVATE crypt32)
    endif()
endif()

if(WITH_BACKTRACE)
    target_compile_definitions(co PRIVATE HAS_BACKTRACE_H)
    target_link_libraries(co PUBLIC backtrace)
endif()

if(DISABLE_HOOK)
    target_compile_definitions(co PRIVATE _CO_DISABLE_HOOK)
endif()

target_compile_features(co PUBLIC cxx_std_11)

if(FPIC)
    set_target_properties(co PROPERTIES POSITION_INDEPENDENT_CODE ON)
endif()

find_package(Threads REQUIRED)
target_link_libraries(co
    PUBLIC Threads::Threads
    PRIVATE ${CMAKE_DL_LIBS}
)

if(BUILD_WITH_SYSTEMD AND UNIX AND NOT APPLE)
    pkg_check_modules(Systemd REQUIRED IMPORTED_TARGET libsystemd)
    target_link_libraries(co PRIVATE
      PkgConfig::Systemd
    )
    add_definitions(-DBUILD_WITH_SYSTEMD)
endif()

if(BUILD_SHARED_LIBS)
    set_target_properties(co
        PROPERTIES
            CXX_VISIBILITY_PRESET hidden
            VISIBILITY_INLINES_HIDDEN ON
    )
    target_compile_definitions(co PRIVATE BUILDING_CO_SHARED)
    set(COOST_SHARED 1)
else()
    set(COOST_SHARED 0)
endif()
configure_file(
    "${PROJECT_SOURCE_DIR}/include/co/config.h.in"
    "${PROJECT_SOURCE_DIR}/include/co/config.h"
)

if(WIN32)
    target_compile_definitions(co
        PRIVATE
            WIN32_LEAN_AND_MEAN
            _WINSOCK_DEPRECATED_NO_WARNINGS
    )
    if (MINGW)
        target_compile_definitions(co
            PRIVATE
            __MINGW_USE_VC2005_COMPAT=1
        )
        target_link_libraries(co PUBLIC ws2_32)
    endif()
    target_link_libraries(co PUBLIC ws2_32)
else()
    #include(CheckIncludeFiles)
    #include(CheckIncludeFileCXX)
    #check_include_files(backtrace.h HAS_BACKTRACE)
    #check_include_file_cxx(cxxabi.h HAS_CXXABI)
    #if(HAS_BACKTRACE)
    #    target_compile_definitions(co PRIVATE HAS_BACKTRACE_H)
    #    target_link_libraries(co PUBLIC backtrace)
    #endif()
    #if(HAS_CXXABI)
    #    target_compile_definitions(co PRIVATE HAS_CXXABI_H)
    #endif()
endif()

# Installation

## library & public headers
install(
    TARGETS co
    EXPORT coostExport
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)

#install(
#    DIRECTORY ${PROJECT_SOURCE_DIR}/include/co
#    DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
#)

## license
install(
    FILES ${PROJECT_SOURCE_DIR}/LICENSE.md
    DESTINATION ${CMAKE_INSTALL_DOCDIR}
)

## pkgconfig file
if(WIN32)
    string(APPEND CO_PKG_EXTRA_LIBS " -lws2_32")
else()
    if(UNIX AND NOT APPLE)
        string(APPEND CO_PKG_EXTRA_LIBS " -lpthread")
        if(NOT BUILD_SHARED_LIBS)
            string(APPEND CO_PKG_EXTRA_LIBS " -ldl")
        endif()
    endif()
    if(WITH_BACKTRACE)
        string(APPEND CO_PKG_EXTRA_LIBS " -lbacktrace")
    endif()
endif()
if(WITH_LIBCURL AND NOT BUILD_SHARED_LIBS)
    string(APPEND CO_PKG_REQUIRES " libcurl")
endif()
if((WITH_LIBCURL OR WITH_OPENSSL) AND NOT BUILD_SHARED_LIBS)
    string(APPEND CO_PKG_REQUIRES " openssl >= 1.1.0")
endif()

configure_file(
    ${PROJECT_SOURCE_DIR}/cmake/coost.pc.in
    coost.pc
    @ONLY
)

install(
    FILES ${CMAKE_CURRENT_BINARY_DIR}/coost.pc
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
)

## CMake config file
set(CO_CMAKE_CONFIG_DEPS "find_dependency(Threads)\n")
if(WITH_LIBCURL)
    string(APPEND CO_CMAKE_CONFIG_DEPS "find_dependency(CURL)\n")
endif()
if(WITH_LIBCURL OR WITH_OPENSSL)
    string(APPEND CO_CMAKE_CONFIG_DEPS "find_dependency(OpenSSL 1.1.0)\n")
endif()

configure_package_config_file(
    ${PROJECT_SOURCE_DIR}/cmake/coostConfig.cmake.in
    coostConfig.cmake
    INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/coost
)

write_basic_package_version_file(
    coostConfigVersion.cmake
    VERSION ${PROJECT_VERSION}
    COMPATIBILITY AnyNewerVersion
)

export(
    EXPORT coostExport
    NAMESPACE coost::
    FILE coostTargets.cmake
)

install(
    EXPORT coostExport
    NAMESPACE coost::
    FILE coostTargets.cmake
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/coost
)

install(
    FILES
        ${CMAKE_CURRENT_BINARY_DIR}/coostConfig.cmake
        ${CMAKE_CURRENT_BINARY_DIR}/coostConfigVersion.cmake
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/coost
)

export(PACKAGE coost)

=== 3rdparty/coost/test/CMakeLists.txt ===
file(GLOB_RECURSE ALL_TEST_FILES "*.cc")

foreach(TEST_FILE ${ALL_TEST_FILES})
    get_filename_component(TEST_FILE_NAME ${TEST_FILE} NAME)
    string(REPLACE ".cc" "" TEST_TARGET ${TEST_FILE_NAME})
    message("  - ${TEST_FILE} --> ${TEST_TARGET}")

    add_executable(${TEST_TARGET}_test ${TEST_FILE})

    set_target_properties(${TEST_TARGET}_test
        PROPERTIES OUTPUT_NAME ${TEST_TARGET}
    )

    target_link_libraries(${TEST_TARGET}_test PRIVATE co)

    add_test(NAME ${TEST_TARGET}_test COMMAND ${TEST_TARGET}_test)
endforeach(TEST_FILE ${ALL_TEST_FILES})

=== 3rdparty/coost/unitest/CMakeLists.txt ===
file(GLOB SRC_FILES *.cc)

add_executable(unitest ${SRC_FILES})
target_link_libraries(unitest PRIVATE co)
add_test(NAME unitest COMMAND unitest)

=== 3rdparty/fmt/test/CMakeLists.txt ===
add_subdirectory(gtest)

include(CheckSymbolExists)

set(TEST_MAIN_SRC test-main.cc gtest-extra.cc gtest-extra.h util.cc)
add_library(test-main STATIC ${TEST_MAIN_SRC})
target_include_directories(test-main PUBLIC
  $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>)
target_link_libraries(test-main gtest fmt)

function(add_fmt_executable name)
  add_executable(${name} ${ARGN})
  # (Wstringop-overflow) - [meta-bug] bogus/missing -Wstringop-overflow warnings
  #   https://gcc.gnu.org/bugzilla/show_bug.cgi?id=88443
  # Bogus -Wstringop-overflow warning
  #   https://gcc.gnu.org/bugzilla/show_bug.cgi?id=100395
  # [10 Regression] spurious -Wstringop-overflow writing to a trailing array plus offset
  #   https://gcc.gnu.org/bugzilla/show_bug.cgi?id=95353
  if (CMAKE_CXX_COMPILER_ID MATCHES "GNU" AND
      NOT CMAKE_CXX_COMPILER_VERSION VERSION_LESS 7.0)
    target_compile_options(${name} PRIVATE -Wno-stringop-overflow)
    # The linker flag is needed for LTO.
    target_link_libraries(${name} -Wno-stringop-overflow)
  endif ()
endfunction()

# Adds a test.
# Usage: add_fmt_test(name srcs...)
function(add_fmt_test name)
  cmake_parse_arguments(ADD_FMT_TEST "HEADER_ONLY;MODULE" "" "" ${ARGN})

  set(sources ${name}.cc ${ADD_FMT_TEST_UNPARSED_ARGUMENTS})
  if (ADD_FMT_TEST_HEADER_ONLY)
    set(sources ${sources} ${TEST_MAIN_SRC} ../src/os.cc)
    set(libs gtest fmt-header-only)
    if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
      set(PEDANTIC_COMPILE_FLAGS ${PEDANTIC_COMPILE_FLAGS} -Wno-weak-vtables)
    endif ()
  elseif (ADD_FMT_TEST_MODULE)
    set(libs test-main test-module)
    set_source_files_properties(${name}.cc PROPERTIES OBJECT_DEPENDS test-module)
  else ()
    set(libs test-main fmt)
  endif ()
  add_fmt_executable(${name} ${sources})
  target_link_libraries(${name} ${libs})

  # Define if certain C++ features can be used.
  if (FMT_PEDANTIC)
    target_compile_options(${name} PRIVATE ${PEDANTIC_COMPILE_FLAGS})
  endif ()
  if (FMT_WERROR)
    target_compile_options(${name} PRIVATE ${WERROR_FLAG})
  endif ()
  add_test(NAME ${name} COMMAND ${name})
endfunction()

if (FMT_MODULE)
  return ()
endif ()

add_fmt_test(args-test)
add_fmt_test(base-test)
add_fmt_test(assert-test)
add_fmt_test(chrono-test)
add_fmt_test(color-test)
add_fmt_test(gtest-extra-test)
add_fmt_test(format-test mock-allocator.h)
if (MSVC)
  target_compile_options(format-test PRIVATE /bigobj)
endif ()
if (NOT (MSVC AND BUILD_SHARED_LIBS))
  add_fmt_test(format-impl-test HEADER_ONLY header-only-test.cc)
endif ()
add_fmt_test(ostream-test)
add_fmt_test(compile-test)
add_fmt_test(compile-fp-test HEADER_ONLY)
if (MSVC)
  # Without this option, MSVC returns 199711L for the __cplusplus macro.
  target_compile_options(compile-fp-test PRIVATE /Zc:__cplusplus)
endif()
add_fmt_test(printf-test)
add_fmt_test(ranges-test ranges-odr-test.cc)

add_fmt_test(scan-test HEADER_ONLY)
check_symbol_exists(strptime "time.h" HAVE_STRPTIME)
if (HAVE_STRPTIME)
  target_compile_definitions(scan-test PRIVATE FMT_HAVE_STRPTIME)
endif ()

add_fmt_test(std-test)
try_compile(compile_result_unused
            ${CMAKE_CURRENT_BINARY_DIR}
            SOURCES ${CMAKE_CURRENT_LIST_DIR}/detect-stdfs.cc
            OUTPUT_VARIABLE RAWOUTPUT)
string(REGEX REPLACE ".*libfound \"([^\"]*)\".*" "\\1" STDLIBFS "${RAWOUTPUT}")
if (STDLIBFS)
  target_link_libraries(std-test ${STDLIBFS})
endif ()
add_fmt_test(unicode-test HEADER_ONLY)
if (MSVC)
  target_compile_options(unicode-test PRIVATE /utf-8)
endif ()
add_fmt_test(xchar-test)
add_fmt_test(enforce-checks-test)
target_compile_definitions(enforce-checks-test PRIVATE
                           -DFMT_ENFORCE_COMPILE_STRING)

if (FMT_MODULE)
  # The tests need {fmt} to be compiled as traditional library
  # because of visibility of implementation details.
  # If module support is present the module tests require a
  # test-only module to be built from {fmt}
  add_library(test-module OBJECT ${CMAKE_SOURCE_DIR}/src/fmt.cc)
  target_compile_features(test-module PUBLIC cxx_std_11)
  target_include_directories(test-module PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>)
  enable_module(test-module)

  add_fmt_test(module-test MODULE test-main.cc)
  if (MSVC)
    target_compile_options(test-module PRIVATE /utf-8 /Zc:__cplusplus
                           /Zc:externConstexpr /Zc:inline)
    target_compile_options(module-test PRIVATE /utf-8 /Zc:__cplusplus
                           /Zc:externConstexpr /Zc:inline)
  endif ()
endif ()

if (NOT DEFINED MSVC_STATIC_RUNTIME AND MSVC)
  foreach (flag_var
			 CMAKE_CXX_FLAGS CMAKE_CXX_FLAGS_DEBUG CMAKE_CXX_FLAGS_RELEASE
			 CMAKE_CXX_FLAGS_MINSIZEREL CMAKE_CXX_FLAGS_RELWITHDEBINFO)
	if (${flag_var} MATCHES "^(/|-)(MT|MTd)")
	  set(MSVC_STATIC_RUNTIME ON)
	  break()
	endif()
  endforeach()
endif()

if (NOT MSVC_STATIC_RUNTIME)
  add_fmt_executable(posix-mock-test
    posix-mock-test.cc ../src/format.cc ${TEST_MAIN_SRC})
  target_include_directories(
    posix-mock-test PRIVATE ${PROJECT_SOURCE_DIR}/include)
  target_link_libraries(posix-mock-test gtest)
  if (FMT_PEDANTIC)
    target_compile_options(posix-mock-test PRIVATE ${PEDANTIC_COMPILE_FLAGS})
  endif ()
  add_test(NAME posix-mock-test COMMAND posix-mock-test)
  add_fmt_test(os-test)
endif ()

message(STATUS "FMT_PEDANTIC: ${FMT_PEDANTIC}")

if (FMT_PEDANTIC)
  # Test that the library can be compiled with exceptions disabled.
  # -fno-exception is broken in icc: https://github.com/fmtlib/fmt/issues/822.
  if (NOT CMAKE_CXX_COMPILER_ID STREQUAL "Intel")
    check_cxx_compiler_flag(-fno-exceptions HAVE_FNO_EXCEPTIONS_FLAG)
  endif ()
  if (HAVE_FNO_EXCEPTIONS_FLAG)
    add_library(noexception-test ../src/format.cc noexception-test.cc)
    target_include_directories(
      noexception-test PRIVATE ${PROJECT_SOURCE_DIR}/include)
    target_compile_options(noexception-test PRIVATE -fno-exceptions)
    target_compile_options(noexception-test PRIVATE ${PEDANTIC_COMPILE_FLAGS})
  endif ()

  # Test that the library compiles without locale.
  add_library(nolocale-test ../src/format.cc)
  target_include_directories(
    nolocale-test PRIVATE ${PROJECT_SOURCE_DIR}/include)
  target_compile_definitions(
    nolocale-test PRIVATE FMT_STATIC_THOUSANDS_SEPARATOR=1)
endif ()

# These tests are disabled on Windows because they take too long.
# They are disabled on GCC < 4.9 because it can not parse UDLs without
# a space after `operator""` but that is an incorrect syntax for any more
# modern compiler.
if (FMT_PEDANTIC AND NOT WIN32 AND NOT (
    CMAKE_CXX_COMPILER_ID MATCHES "GNU" AND
    CMAKE_CXX_COMPILER_VERSION VERSION_LESS 4.9))
  # Test if incorrect API usages produce compilation error.
  add_test(compile-error-test ${CMAKE_CTEST_COMMAND}
    --build-and-test
    "${CMAKE_CURRENT_SOURCE_DIR}/compile-error-test"
    "${CMAKE_CURRENT_BINARY_DIR}/compile-error-test"
    --build-generator ${CMAKE_GENERATOR}
    --build-makeprogram ${CMAKE_MAKE_PROGRAM}
    --build-options
    "-DCMAKE_CXX_COMPILER=${CMAKE_CXX_COMPILER}"
    "-DCMAKE_CXX_FLAGS=${CMAKE_CXX_FLAGS}"
    "-DCMAKE_CXX_STANDARD=${CMAKE_CXX_STANDARD}"
    "-DCXX_STANDARD_FLAG=${CXX_STANDARD_FLAG}"
    "-DFMT_DIR=${CMAKE_SOURCE_DIR}")

  # Test if the targets are found from the build directory.
  add_test(find-package-test ${CMAKE_CTEST_COMMAND}
    -C ${CMAKE_BUILD_TYPE}
    --build-and-test
    "${CMAKE_CURRENT_SOURCE_DIR}/find-package-test"
    "${CMAKE_CURRENT_BINARY_DIR}/find-package-test"
    --build-generator ${CMAKE_GENERATOR}
    --build-makeprogram ${CMAKE_MAKE_PROGRAM}
    --build-options
    "-DCMAKE_CXX_COMPILER=${CMAKE_CXX_COMPILER}"
    "-DCMAKE_CXX_FLAGS=${CMAKE_CXX_FLAGS}"
    "-DCMAKE_CXX_STANDARD=${CMAKE_CXX_STANDARD}"
    "-DFMT_DIR=${PROJECT_BINARY_DIR}"
    "-DPEDANTIC_COMPILE_FLAGS=${PEDANTIC_COMPILE_FLAGS}"
    "-DCMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE}")

  # Test if the targets are found when add_subdirectory is used.
  add_test(add-subdirectory-test ${CMAKE_CTEST_COMMAND}
    -C ${CMAKE_BUILD_TYPE}
    --build-and-test
    "${CMAKE_CURRENT_SOURCE_DIR}/add-subdirectory-test"
    "${CMAKE_CURRENT_BINARY_DIR}/add-subdirectory-test"
    --build-generator ${CMAKE_GENERATOR}
    --build-makeprogram ${CMAKE_MAKE_PROGRAM}
    --build-options
    "-DCMAKE_CXX_COMPILER=${CMAKE_CXX_COMPILER}"
    "-DCMAKE_CXX_STANDARD=${CMAKE_CXX_STANDARD}"
    "-DPEDANTIC_COMPILE_FLAGS=${PEDANTIC_COMPILE_FLAGS}"
    "-DCMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE}")
endif ()

# This test are disabled on Windows because it is only *NIX issue.
if (FMT_PEDANTIC AND NOT WIN32)
  add_test(static-export-test ${CMAKE_CTEST_COMMAND}
    -C ${CMAKE_BUILD_TYPE}
    --build-and-test
    "${CMAKE_CURRENT_SOURCE_DIR}/static-export-test"
    "${CMAKE_CURRENT_BINARY_DIR}/static-export-test"
    --build-generator ${CMAKE_GENERATOR}
    --build-makeprogram ${CMAKE_MAKE_PROGRAM}
    --build-options
    "-DCMAKE_CXX_COMPILER=${CMAKE_CXX_COMPILER}"
    "-DCMAKE_CXX_STANDARD=${CMAKE_CXX_STANDARD}"
    "-DCMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE}")
endif ()

# Activate optional CUDA tests if CUDA is found. For version selection see
# https://docs.nvidia.com/cuda/cuda-c-programming-guide/index.html#cpp14-language-features
if (FMT_CUDA_TEST)
  if (${CMAKE_VERSION} VERSION_LESS 3.15)
    find_package(CUDA 9.0)
  else ()
    include(CheckLanguage)
    check_language(CUDA)
    if (CMAKE_CUDA_COMPILER)
      enable_language(CUDA OPTIONAL)
      set(CUDA_FOUND TRUE)
    endif ()
  endif ()

  if (CUDA_FOUND)
    add_subdirectory(cuda-test)
    add_test(NAME cuda-test COMMAND fmt-in-cuda-test)
  endif ()
endif ()

=== debian/changelog ===
dde-cooperation (1.1.21) unstable; urgency=medium

  * chore: Update version to 1.1.21.
  * fix: Implement graceful shutdown process in TransferHelper
  * fix: Fix network connect tips
  * fix: Fix not show offline device if not same subnet.
  * fix: Fix not show device for NotAllow mode
  * fix: Fix transfer dialog still show issue

 -- re2zero <yangwu@uniontech.com>  Fri, 10 Oct 2025 13:31:19 +0800

dde-cooperation (1.1.20) unstable; urgency=medium

  * chore: Update version to 1.1.20.
  * fix: Fix some UI issues.
  * fix: Add delay before application exit to ensure config is saved
  * fix: Disable search by self IP

 -- re2zero <yangwu@uniontech.com>  Thu, 18 Sep 2025 19:02:33 +0800

dde-cooperation (1.1.19) unstable; urgency=medium

  * chore: Update version to 1.1.19.
  * fix: Update notification handling to prevent showing in notification center
  * fix: disable logging for sensitive information

 -- re2zero <yangwu@uniontech.com>  Thu, 11 Sep 2025 13:56:43 +0800

dde-cooperation (1.1.18) unstable; urgency=medium

  * chore: Update version to 1.1.18. 

 -- Tian ShiLin <tianshilin@uniontech.com>  Wed, 20 Aug 2025 14:23:54 +0800

dde-cooperation (1.1.17) unstable; urgency=medium

  * chore: Update version to 1.1.16

 -- dengzhongyuan <dengzhongyuan@uniontech.com>  Thu, 14 Aug 2025 11:30:59 +0800

=== debian/control ===
Source: dde-cooperation
Priority: optional
Maintainer: Deepin Packages Builder <packages@linuxdeepin.com>
Build-Depends:
 debhelper (>= 11),
 pkg-config,
 cmake,
 qt6-5compat-dev | libqt5x11extras5-dev,
 qt6-base-dev | qtbase5-dev,
 qt6-tools-dev-tools | qttools5-dev-tools,
 qt6-tools-dev | qttools5-dev,
 qt6-svg-dev | libqt5svg5-dev,
 libdtk6widget-dev | libdtkwidget-dev,
 libdtk6gui-dev | libdtkgui-dev,
 libdtk6core-dev | libdtkcore-dev,
 libssl-dev,
 libzip-dev,
 libcurl4-openssl-dev,
 libxtst-dev,
 libavahi-compat-libdnssd-dev,
 libxinerama-dev,
 libxrandr-dev,
 libxrender-dev,
 libxkbcommon-dev,
 libx11-dev,
 libice-dev,
 libsm-dev,
 uuid-dev,
 libsystemd-dev,
 libqrencode-dev,
 libvncserver-dev,
 dde-file-manager-dev,
Standards-Version: 4.1.3
Section: utils
Homepage: https://github.com/linuxdeepin/dde-cooperation

Package: dde-cooperation-dev
Section: libdevel
Architecture: any
Depends: dde-cooperation (= ${binary:Version}), ${misc:Depends}
Description: Development package for deepin cooperation application
 This package contains the header files and static libraries

Package: deepin-data-transfer
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: deepin data transfer application
 Deepin Desktop Environment (DDE) - data transfer application.

Package: dde-cooperation
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
 libqrencode4,
 dde-cooperation-transfer
Replaces:
 QtZeroConf,
 dde-cooperation-daemon (<< 1.0.0),
Description: deepin cooperation application
 Deepin Desktop Environment (DDE) - cooperation application.

Package: dde-cooperation-transfer
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces:
 dfmplugin-cooperation
Description: deepin file delivery
 Deepin Desktop Environment (DDE) - file transfer application.

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/default.mk

# 检测当前安装的Qt版本，优先使用Qt6，否则使用Qt5
define detect_qt_version
ifneq (,$(shell which qmake6 2>/dev/null))
    QT_DIR="/usr/lib/$(DEB_HOST_MULTIARCH)/cmake/Qt6"
else
    QT_DIR="/usr/lib/$(DEB_HOST_MULTIARCH)/cmake/Qt5"
endif
endef

# 调用检测Qt版本的命令
$(eval $(call detect_qt_version))

# hardcode this if want to force build with sepecific Qt version
# QT_DIR="/usr/lib/$(DEB_HOST_MULTIARCH)/cmake/Qt5"

DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)

%:
	dh $@ --parallel

override_dh_auto_configure:
	dh_auto_configure -- \
	-DCMAKE_INSTALL_PREFIX=/usr \
	-DCMAKE_BUILD_TYPE=Release \
	-DHOST_MULTIARCH="$(DEB_HOST_MULTIARCH)" \
	-DAPP_VERSION=$(DEB_VERSION_UPSTREAM) \
	-DQT_DIR=$(QT_DIR)
